module.exports = {
  root: true,
  extends: 'eslint:recommended',
  env: {
    node: true,
    mocha: true,
  },
  plugins: [
    'chai-expect',
  ],
  rules: {
    /*** Possible Errors ***/

    'comma-dangle': 0,
    'no-cond-assign': [2, 'except-parens'],
    'no-console': 0,
    'no-debugger': 0,
    'no-empty': 2,

    /*** Best Practices ***/

    'curly': 2,
    'eqeqeq': 2,
    'guard-for-in': 0,
    'no-caller': 2,
    'no-eq-null': 2,
    'no-eval': 2,
    'no-new': 0,
    'wrap-iife': 0,
    'yoda': 2,

    /*** Strict Mode ***/

    'strict': 0,

    /*** Variables ***/

    'no-undef': 2,
    'no-unused-vars': 2,
    'no-use-before-define': [2, 'nofunc'],

    /*** Stylistic Issues ***/

    'camelcase': 2,
    'eol-last': 2,
    'indent': [0, 2, {
      'SwitchCase': 1,
      'VariableDeclarator': { 'var': 2, 'let': 2, 'const': 3 }
    }],
    'keyword-spacing': 0,
    'linebreak-style': [2, 'unix'],
    'new-cap': [2, {
      properties: false,
    }],
    'no-plusplus': 0,
    'no-trailing-spaces': 2,
    'no-unneeded-ternary': 2,
    'space-before-blocks': 2,
    'space-in-parens': 2,
    'space-infix-ops': 2,
    'space-unary-ops': 2,
    'quotes': [2, 'single'],

    // disabled due to chai expect assertions
    'no-unused-expressions': 0,

    'chai-expect/missing-assertion': 2,
    'chai-expect/terminating-properties': 2,
    'chai-expect/no-inner-compare': 2,
  },
};
