import fixturify from 'fixturify';
import { PackageJson } from 'type-fest';
declare class Project {
    pkg: PackageJson;
    files: fixturify.DirJSON;
    readonly isDependency = true;
    private _dependencies;
    private _devDependencies;
    private _root;
    private _tmp;
    constructor(name: string, version?: string, cb?: (project: Project) => void, root?: string);
    get root(): string;
    get baseDir(): string;
    get name(): string;
    set name(value: string);
    get version(): string;
    set version(value: string);
    static fromJSON(json: fixturify.DirJSON, name: string): Project;
    static fromDir(root: string, name?: string): Project;
    writeSync(root?: string): void;
    readSync(root?: string): void;
    addDependency(name: string | Project, version?: string, cb?: (project: Project) => void): Project;
    removeDependency(name: string): void;
    removeDevDependency(name: string): void;
    addDevDependency(name: string | Project, version?: string, cb?: (project: Project) => void): Project;
    dependencies(): Project[];
    devDependencies(): Project[];
    validate(): void;
    toJSON(): fixturify.DirJSON;
    toJSON(key: string): fixturify.DirJSON | string;
    clone(): Project;
    dispose(): void;
}
export = Project;
